Loading...
Searching...
No Matches
casacore::MArrayMath_global_functions_MArray_mathematical_operations Struct Reference
tables package (libcasa_tables) » TaQL_module

More...

`#include <MArrayMath.h>`

## Classes

class | MSumFunc
| Define functors to perform a reduction function on an MArray object. More...
class | MSumSqrFunc
class | MProductFunc
class | MMinFunc
class | MMaxFunc
class | MMeanFunc
class | MVarianceFunc
class | MStddevFunc
class | MAvdevFunc
class | MRmsFunc
class | MMedianFunc
class | MFractileFunc

## Public Member Functions

template<typename T>
MArray< T > | partialArrayMath (const MArray< T > &a, const IPosition &collapseAxes, const MArrayFunctorBase< T > &funcObj)
| Do partial reduction of an MArray object.
template<typename T, typename RES>
void | partialArrayMath (MArray< RES > &res, const MArray< T > &a, const IPosition &collapseAxes, const MArrayFunctorBase< T, RES > &funcObj)
template<typename T>
MArray< T > | boxedArrayMath (const MArray< T > &a, const IPosition &boxShape, const MArrayFunctorBase< T > &funcObj)
template<typename T, typename RES>
void | boxedArrayMath (MArray< RES > &res, const MArray< T > &array, const IPosition &boxShape, const MArrayFunctorBase< T, RES > &funcObj)
template<typename T>
MArray< T > | slidingArrayMath (const MArray< T > &array, const IPosition &halfBoxShape, const MArrayFunctorBase< T > &funcObj, Bool fillEdge=True)
template<typename T, typename RES>
void | slidingArrayMath (MArray< RES > &res, const MArray< T > &array, const IPosition &halfBoxShape, const MArrayFunctorBase< T, RES > &funcObj, Bool fillEdge=True)
template<typename T>
MArray< T > | operator+ (const MArray< T > &left, const MArray< T > &right)
| Add, subtract, etc.
template<typename T>
MArray< T > | operator- (const MArray< T > &left, const MArray< T > &right)
template<typename T>
MArray< T > | operator* (const MArray< T > &left, const MArray< T > &right)
template<typename T>
MArray< T > | operator/ (const MArray< T > &left, const MArray< T > &right)
template<typename T>
MArray< T > | operator% (const MArray< T > &left, const MArray< T > &right)
template<typename T>
MArray< T > | operator& (const MArray< T > &left, const MArray< T > &right)
template<typename T>
MArray< T > | operator| (const MArray< T > &left, const MArray< T > &right)
template<typename T>
MArray< T > | operator^ (const MArray< T > &left, const MArray< T > &right)
template<typename T>
MArray< T > | operator+ (const MArray< T > &left, const T &right)
template<typename T>
MArray< T > | operator- (const MArray< T > &left, const T &right)
template<typename T>
MArray< T > | operator* (const MArray< T > &left, const T &right)
template<typename T>
MArray< T > | operator/ (const MArray< T > &left, const T &right)
template<typename T>
MArray< T > | operator% (const MArray< T > &left, const T &right)
template<typename T>
MArray< T > | operator& (const MArray< T > &left, const T &right)
template<typename T>
MArray< T > | operator| (const MArray< T > &left, const T &right)
template<typename T>
MArray< T > | operator^ (const MArray< T > &left, const T &right)
template<typename T>
MArray< T > | operator+ (const T &left, const MArray< T > &right)
template<typename T>
MArray< T > | operator- (const T &left, const MArray< T > &right)
template<typename T>
MArray< T > | operator* (const T &left, const MArray< T > &right)
template<typename T>
MArray< T > | operator/ (const T &left, const MArray< T > &right)
template<typename T>
MArray< T > | operator% (const T &left, const MArray< T > &right)
template<typename T>
MArray< T > | operator& (const T &left, const MArray< T > &right)
template<typename T>
MArray< T > | operator| (const T &left, const MArray< T > &right)
template<typename T>
MArray< T > | operator^ (const T &left, const MArray< T > &right)
template<typename T>
MArray< T > | operator- (const MArray< T > &a)
| Negate the elements in an array.
template<typename T>
MArray< T > | operator~ (const MArray< T > &a)
| Take the complement of the elements in an array.
template<typename T>
MArray< T > | sin (const MArray< T > &a)
| Perform mathematical function on each element in an array.
template<typename T>
MArray< T > | cos (const MArray< T > &a)
template<typename T>
MArray< T > | tan (const MArray< T > &a)
template<typename T>
MArray< T > | sinh (const MArray< T > &a)
template<typename T>
MArray< T > | cosh (const MArray< T > &a)
template<typename T>
MArray< T > | tanh (const MArray< T > &a)
template<typename T>
MArray< T > | asin (const MArray< T > &a)
template<typename T>
MArray< T > | acos (const MArray< T > &a)
template<typename T>
MArray< T > | atan (const MArray< T > &a)
template<typename T>
MArray< T > | atan2 (const MArray< T > &left, const MArray< T > &right)
template<typename T>
MArray< T > | atan2 (const MArray< T > &left, const T &right)
template<typename T>
MArray< T > | atan2 (const T &left, const MArray< T > &right)
template<typename T>
MArray< T > | exp (const MArray< T > &a)
template<typename T>
MArray< T > | log (const MArray< T > &a)
template<typename T>
MArray< T > | log10 (const MArray< T > &a)
template<typename T>
MArray< T > | sqrt (const MArray< T > &a)
template<typename T>
MArray< T > | square (const MArray< T > &a)
template<typename T>
MArray< T > | cube (const MArray< T > &a)
template<typename T>
MArray< T > | pow (const MArray< T > &a, const MArray< T > &exp)
template<typename T>
MArray< T > | pow (const T &a, const MArray< T > &exp)
template<typename T>
MArray< T > | pow (const MArray< T > &a, const T &exp)
template<typename T>
MArray< std::complex< T > > | pow (const MArray< std::complex< T > > &a, const T &exp)
template<typename T>
MArray< T > | min (const MArray< T > &left, const MArray< T > &right)
template<typename T>
MArray< T > | min (const MArray< T > &left, const T &right)
template<typename T>
MArray< T > | min (const T &left, const MArray< T > &right)
template<typename T>
MArray< T > | max (const MArray< T > &left, const MArray< T > &right)
template<typename T>
MArray< T > | max (const MArray< T > &left, const T &right)
template<typename T>
MArray< T > | max (const T &left, const MArray< T > &right)
template<typename T>
MArray< T > | ceil (const MArray< T > &a)
template<typename T>
MArray< T > | floor (const MArray< T > &a)
template<typename T>
MArray< T > | round (const MArray< T > &a)
template<typename T>
MArray< T > | sign (const MArray< T > &a)
template<typename T>
MArray< T > | abs (const MArray< T > &a)
template<typename T>
MArray< T > | fabs (const MArray< T > &a)
template<typename T>
MArray< T > | fmod (const MArray< T > &left, const MArray< T > &right)
template<typename T>
MArray< T > | fmod (const MArray< T > &left, const T &right)
template<typename T>
MArray< T > | fmod (const T &left, const MArray< T > &right)
template<typename T>
MArray< T > | floormod (const MArray< T > &left, const MArray< T > &right)
template<typename T>
MArray< T > | floormod (const MArray< T > &left, const T &right)
template<typename T>
MArray< T > | floormod (const T &left, const MArray< T > &right)
template<typename T>
MArray< T > | conj (const MArray< T > &arr)
MArray< Float > | real (const MArray< Complex > &arr)
MArray< Float > | imag (const MArray< Complex > &arr)
MArray< Float > | amplitude (const MArray< Complex > &arr)
MArray< Float > | phase (const MArray< Complex > &arr)
MArray< Double > | real (const MArray< DComplex > &arr)
MArray< Double > | imag (const MArray< DComplex > &arr)
MArray< Double > | amplitude (const MArray< DComplex > &arr)
MArray< Double > | phase (const MArray< DComplex > &arr)
template<typename T>
T | sum (const MArray< T > &a)
| Reduce an array to a scalar using the unmasked elements only.
template<typename T>
T | sumsqr (const MArray< T > &a)
template<typename T>
T | product (const MArray< T > &a)
template<typename T>
T | min (const MArray< T > &a)
template<typename T>
T | max (const MArray< T > &a)
template<typename T>
T | mean (const MArray< T > &a)
template<typename T>
T | variance (const MArray< T > &a, T mean, uInt ddof)
template<typename T>
T | variance (const MArray< T > &a, uInt ddof)
template<typename T>
T | stddev (const MArray< T > &a, uInt ddof)
template<typename T>
T | stddev (const MArray< T > &a, T mean, uInt ddof)
template<typename T>
T | avdev (const MArray< T > &a, T mean)
template<typename T>
T | avdev (const MArray< T > &a)
template<typename T>
T | rms (const MArray< T > &a)
template<typename T>
T | median (const MArray< T > &a, Bool sorted, Bool takeEvenMean, Bool inPlace=False)
template<typename T>
T | median (const MArray< T > &a)
template<typename T>
T | median (const MArray< T > &a, Bool sorted)
template<typename T>
T | medianInPlace (const MArray< T > &a, Bool sorted=False)
template<typename T>
T | fractile (const MArray< T > &a, Float fraction, Bool sorted=False, Bool inPlace=False)
| Return the fractile of an array.
template<typename T>
MArray< T > | partialSums (const MArray< T > &a, const IPosition &collapseAxes)
| Get partial sums, etc.
template<typename T>
MArray< T > | partialSumSqrs (const MArray< T > &a, const IPosition &collapseAxes)
template<typename T>
MArray< T > | partialProducts (const MArray< T > &a, const IPosition &collapseAxes)
template<typename T>
MArray< T > | partialMins (const MArray< T > &a, const IPosition &collapseAxes)
template<typename T>
MArray< T > | partialMaxs (const MArray< T > &a, const IPosition &collapseAxes)
template<typename T>
MArray< T > | partialMeans (const MArray< T > &a, const IPosition &collapseAxes)
template<typename T>
MArray< T > | partialVariances (const MArray< T > &a, const IPosition &collapseAxes, uInt ddof)
template<typename T>
MArray< T > | partialStddevs (const MArray< T > &a, const IPosition &collapseAxes, uInt ddof)
template<typename T>
MArray< T > | partialAvdevs (const MArray< T > &a, const IPosition &collapseAxes)
template<typename T>
MArray< T > | partialRmss (const MArray< T > &a, const IPosition &collapseAxes)
template<typename T>
MArray< T > | partialMedians (const MArray< T > &a, const IPosition &collapseAxes, Bool takeEvenMean=False, Bool inPlace=False)
template<typename T>
MArray< T > | partialFractiles (const MArray< T > &a, const IPosition &collapseAxes, Float fraction, Bool inPlace=False)
template<typename T>
MArray< T > | slidingSums (const MArray< T > &a, const IPosition &halfBoxSize, Bool fillEdge=True)
| Get sliding sums.
template<typename T>
MArray< T > | slidingSumSqrs (const MArray< T > &a, const IPosition &halfBoxSize, Bool fillEdge=True)
template<typename T>
MArray< T > | slidingProducts (const MArray< T > &a, const IPosition &halfBoxSize, Bool fillEdge=True)
template<typename T>
MArray< T > | slidingMins (const MArray< T > &a, const IPosition &halfBoxSize, Bool fillEdge=True)
template<typename T>
MArray< T > | slidingMaxs (const MArray< T > &a, const IPosition &halfBoxSize, Bool fillEdge=True)
template<typename T>
MArray< T > | slidingMeans (const MArray< T > &a, const IPosition &halfBoxSize, Bool fillEdge=True)
template<typename T>
MArray< T > | slidingVariances (const MArray< T > &a, const IPosition &halfBoxSize, uInt ddof, Bool fillEdge=True)
template<typename T>
MArray< T > | slidingStddevs (const MArray< T > &a, const IPosition &halfBoxSize, uInt ddof, Bool fillEdge=True)
template<typename T>
MArray< T > | slidingAvdevs (const MArray< T > &a, const IPosition &halfBoxSize, Bool fillEdge=True)
template<typename T>
MArray< T > | slidingRmss (const MArray< T > &a, const IPosition &halfBoxSize, Bool fillEdge=True)
template<typename T>
MArray< T > | slidingMedians (const MArray< T > &a, const IPosition &halfBoxSize, Bool takeEvenMean=False, Bool inPlace=False, Bool fillEdge=True)
template<typename T>
MArray< T > | slidingFractiles (const MArray< T > &a, const IPosition &halfBoxSize, Float fraction, Bool inPlace=False, Bool fillEdge=True)
template<typename T>
MArray< T > | boxedSums (const MArray< T > &a, const IPosition &boxSize)
| Get boxed sums.
template<typename T>
MArray< T > | boxedSumSqrs (const MArray< T > &a, const IPosition &boxSize)
template<typename T>
MArray< T > | boxedProducts (const MArray< T > &a, const IPosition &boxSize)
template<typename T>
MArray< T > | boxedMins (const MArray< T > &a, const IPosition &boxSize)
template<typename T>
MArray< T > | boxedMaxs (const MArray< T > &a, const IPosition &boxSize)
template<typename T>
MArray< T > | boxedMeans (const MArray< T > &a, const IPosition &boxSize)
template<typename T>
MArray< T > | boxedVariances (const MArray< T > &a, const IPosition &boxSize, uInt ddof)
template<typename T>
MArray< T > | boxedStddevs (const MArray< T > &a, const IPosition &boxSize, uInt ddof)
template<typename T>
MArray< T > | boxedAvdevs (const MArray< T > &a, const IPosition &boxSize)
template<typename T>
MArray< T > | boxedRmss (const MArray< T > &a, const IPosition &boxSize)
template<typename T>
MArray< T > | boxedMedians (const MArray< T > &a, const IPosition &boxSize, Bool takeEvenMean=False, Bool inPlace=False)
template<typename T>
MArray< T > | boxedFractiles (const MArray< T > &a, const IPosition &boxSize, Float fraction, Bool inPlace=False)

## Detailed Description

Mathematical operations for MArray objects.

### Review Status

Reviewed By:
  UNKNOWN
Test programs:
  tMArrayMath

### Prerequisite

- MArray

### Synopsis

These functions perform element by element mathematical operations on optionally masked arrays and/or scalars. If two arrays are used, the arrays must conform, except for allEQ which returns False if the arrays do not conform.

The functions in this file can be divided in 3 groups:

- Full array operations like ==, near, etc. They are defined for array-array and array-scalar operations. Arrays shapes have to be conformant. They operate on all elements (also the masked ones). The result is an MArray with the same shape as the input array(s). It will have a mask if one of the operands has a mask. If both operands have a mask, the resulting mask is the OR of both masks.
- Full reduction functions like ntrue, all, allEQ, etc. They operate on the unmasked elements only. If there are no unmasked elements, the results is 0 or True.
- Reduction functions working on unmasked elements in parts of the input array. The result is an MArray that has a mask if the input array has a mask. An output element is masked off if its input part has no unmasked elements. The functors defined at the beginning of this file are used to operate on each part. There are 3 flavours:
  - partialXXX reduces one or more axes. E.g. one can count the number of True elements for particular array axes. The result is an array with a lower dimensionality. They can be seen as a special versions of the boxedXXX functions.
  - slidingXXX operates in a sliding window over the array. So the result is an array with the same shape as the input, although the output array is smaller if the edge is not filled.
  - boxedXXX divides the input array in boxes with the given size and operates on each box. The result is an array with the same dimensionality, but with a smaller size. If the box size does not fit integrally, the edge box is smaller.

Definition at line 94 of file MArrayMath.h.

## Member Function Documentation

## abs()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::abs | ( | const MArray< T > & | a | ) |

inline

Definition at line 642 of file MArrayMath.h.

References abs(), and casacore::MArray< T >::array().

Referenced by abs().

## acos()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::acos | ( | const MArray< T > & | a | ) |

inline

Definition at line 534 of file MArrayMath.h.

References acos(), and casacore::MArray< T >::array().

Referenced by acos().

## amplitude() [1/2]

MArray< Float > casacore::MArrayMath_global_functions_MArray_mathematical_operations::amplitude | ( | const MArray< Complex > & | arr | ) |

inline

Definition at line 687 of file MArrayMath.h.

References amplitude(), and casacore::MArray< T >::array().

Referenced by amplitude(), and amplitude().

## amplitude() [2/2]

MArray< Double > casacore::MArrayMath_global_functions_MArray_mathematical_operations::amplitude | ( | const MArray< DComplex > & | arr | ) |

inline

Definition at line 699 of file MArrayMath.h.

References amplitude(), and casacore::MArray< T >::array().

## asin()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::asin | ( | const MArray< T > & | a | ) |

inline

Definition at line 530 of file MArrayMath.h.

References casacore::MArray< T >::array(), and asin().

Referenced by asin().

## atan()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::atan | ( | const MArray< T > & | a | ) |

inline

Definition at line 538 of file MArrayMath.h.

References casacore::MArray< T >::array(), and atan().

Referenced by atan().

## atan2() [1/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::atan2 | ( | const MArray< T > & | left,
|  | const MArray< T > & | right )

inline

Definition at line 542 of file MArrayMath.h.

References casacore::MArray< T >::array(), atan2(), casacore::MArrayBase::combineMask(), and casacore::MArrayBase::isNull().

Referenced by atan2(), atan2(), and atan2().

## atan2() [2/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::atan2 | ( | const MArray< T > & | left,
|  | const T & | right )

inline

Definition at line 548 of file MArrayMath.h.

References casacore::MArray< T >::array(), and atan2().

## atan2() [3/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::atan2 | ( | const T & | left,
|  | const MArray< T > & | right )

inline

Definition at line 552 of file MArrayMath.h.

References casacore::MArray< T >::array(), and atan2().

## avdev() [1/2]

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::avdev | ( | const MArray< T > & | a | ) |

inline

Definition at line 831 of file MArrayMath.h.

References avdev(), and mean().

## avdev() [2/2]

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::avdev | ( | const MArray< T > & | a,
|  | T | mean )

inline

Definition at line 817 of file MArrayMath.h.

References casacore::MArray< T >::array(), avdev(), casacore::Array< T >::begin(), casacore::Array< T >::cbegin(), casacore::ArrayBase::contiguousStorage(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::mask(), mean(), casacore::MArrayBase::nvalid(), and sum().

Referenced by avdev(), avdev(), and casacore::MArrayMath_global_functions_MArray_mathematical_operations::MAvdevFunc< T >::operator()().

## boxedArrayMath() [1/2]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::boxedArrayMath | ( | const MArray< T > & | a,
|  | const IPosition & | boxShape,
|  | const MArrayFunctorBase< T > & | funcObj )

inline

Definition at line 249 of file MArrayMath.h.

References boxedArrayMath().

Referenced by boxedArrayMath(), boxedAvdevs(), boxedFractiles(), boxedMaxs(), boxedMeans(), boxedMedians(), boxedMins(), boxedProducts(), boxedRmss(), boxedStddevs(), boxedSums(), boxedSumSqrs(), and boxedVariances().

## boxedArrayMath() [2/2]

template<typename T, typename RES>

void casacore::MArrayMath_global_functions_MArray_mathematical_operations::boxedArrayMath | ( | MArray< RES > & | res,
|  | const MArray< T > & | array,
|  | const IPosition & | boxShape,
|  | const MArrayFunctorBase< T, RES > & | funcObj )

inline

Loop through all data and assemble as needed.

Definition at line 258 of file MArrayMath.h.

References AlwaysAssert, casacore::array, casacore::MArray< T >::array(), casacore::Array< T >::data(), casacore::False, casacore::fillBoxedShape(), casacore::mask(), casacore::ndim(), casacore::MArray< T >::resize(), casacore::MArrayBase::setMask(), casacore::shape(), and casacore::True.

## boxedAvdevs()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::boxedAvdevs | ( | const MArray< T > & | a,
|  | const IPosition & | boxSize )

inline

Definition at line 1300 of file MArrayMath.h.

References casacore::MArray< T >::array(), boxedArrayMath(), casacore::MArrayBase::hasMask(), and casacore::MArrayBase::isNull().

## boxedFractiles()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::boxedFractiles | ( | const MArray< T > & | a,
|  | const IPosition & | boxSize,
|  | Float | fraction,
|  | Bool | inPlace = False )

inline

Definition at line 1338 of file MArrayMath.h.

References casacore::MArray< T >::array(), boxedArrayMath(), casacore::False, casacore::MArrayBase::hasMask(), and casacore::MArrayBase::isNull().

## boxedMaxs()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::boxedMaxs | ( | const MArray< T > & | a,
|  | const IPosition & | boxSize )

inline

Definition at line 1254 of file MArrayMath.h.

References casacore::MArray< T >::array(), boxedArrayMath(), casacore::MArrayBase::hasMask(), and casacore::MArrayBase::isNull().

## boxedMeans()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::boxedMeans | ( | const MArray< T > & | a,
|  | const IPosition & | boxSize )

inline

Definition at line 1265 of file MArrayMath.h.

References casacore::MArray< T >::array(), boxedArrayMath(), casacore::MArrayBase::hasMask(), and casacore::MArrayBase::isNull().

## boxedMedians()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::boxedMedians | ( | const MArray< T > & | a,
|  | const IPosition & | boxSize,
|  | Bool | takeEvenMean = False,
|  | Bool | inPlace = False )

inline

Definition at line 1322 of file MArrayMath.h.

References casacore::MArray< T >::array(), boxedArrayMath(), casacore::False, casacore::MArrayBase::hasMask(), and casacore::MArrayBase::isNull().

## boxedMins()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::boxedMins | ( | const MArray< T > & | a,
|  | const IPosition & | boxSize )

inline

Definition at line 1243 of file MArrayMath.h.

References casacore::MArray< T >::array(), boxedArrayMath(), casacore::MArrayBase::hasMask(), and casacore::MArrayBase::isNull().

## boxedProducts()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::boxedProducts | ( | const MArray< T > & | a,
|  | const IPosition & | boxSize )

inline

Definition at line 1232 of file MArrayMath.h.

References casacore::MArray< T >::array(), boxedArrayMath(), casacore::MArrayBase::hasMask(), and casacore::MArrayBase::isNull().

## boxedRmss()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::boxedRmss | ( | const MArray< T > & | a,
|  | const IPosition & | boxSize )

inline

Definition at line 1311 of file MArrayMath.h.

References casacore::MArray< T >::array(), boxedArrayMath(), casacore::MArrayBase::hasMask(), and casacore::MArrayBase::isNull().

## boxedStddevs()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::boxedStddevs | ( | const MArray< T > & | a,
|  | const IPosition & | boxSize,
|  | uInt | ddof )

inline

Definition at line 1288 of file MArrayMath.h.

References casacore::MArray< T >::array(), boxedArrayMath(), casacore::MArrayBase::hasMask(), and casacore::MArrayBase::isNull().

## boxedSums()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::boxedSums | ( | const MArray< T > & | a,
|  | const IPosition & | boxSize )

inline

Get boxed sums.

Definition at line 1210 of file MArrayMath.h.

References casacore::MArray< T >::array(), boxedArrayMath(), casacore::MArrayBase::hasMask(), and casacore::MArrayBase::isNull().

## boxedSumSqrs()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::boxedSumSqrs | ( | const MArray< T > & | a,
|  | const IPosition & | boxSize )

inline

Definition at line 1221 of file MArrayMath.h.

References casacore::MArray< T >::array(), boxedArrayMath(), casacore::MArrayBase::hasMask(), and casacore::MArrayBase::isNull().

## boxedVariances()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::boxedVariances | ( | const MArray< T > & | a,
|  | const IPosition & | boxSize,
|  | uInt | ddof )

inline

Definition at line 1276 of file MArrayMath.h.

References casacore::MArray< T >::array(), boxedArrayMath(), casacore::MArrayBase::hasMask(), and casacore::MArrayBase::isNull().

## ceil()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::ceil | ( | const MArray< T > & | a | ) |

inline

Definition at line 626 of file MArrayMath.h.

References casacore::MArray< T >::array(), and ceil().

Referenced by ceil().

## conj()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::conj | ( | const MArray< T > & | arr | ) |

inline

Definition at line 678 of file MArrayMath.h.

References casacore::MArray< T >::array(), and conj().

Referenced by conj().

## cos()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::cos | ( | const MArray< T > & | a | ) |

inline

Definition at line 510 of file MArrayMath.h.

References casacore::MArray< T >::array(), and cos().

Referenced by cos().

## cosh()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::cosh | ( | const MArray< T > & | a | ) |

inline

Definition at line 522 of file MArrayMath.h.

References casacore::MArray< T >::array(), and cosh().

Referenced by cosh().

## cube()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::cube | ( | const MArray< T > & | a | ) |

inline

Definition at line 576 of file MArrayMath.h.

References casacore::MArray< T >::array(), and cube().

Referenced by cube().

## exp()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::exp | ( | const MArray< T > & | a | ) |

inline

Definition at line 556 of file MArrayMath.h.

References casacore::MArray< T >::array(), and exp().

Referenced by exp(), pow(), pow(), pow(), and pow().

## fabs()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::fabs | ( | const MArray< T > & | a | ) |

inline

Definition at line 646 of file MArrayMath.h.

References casacore::MArray< T >::array(), and fabs().

Referenced by fabs().

## floor()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::floor | ( | const MArray< T > & | a | ) |

inline

Definition at line 630 of file MArrayMath.h.

References casacore::MArray< T >::array(), and floor().

Referenced by floor().

## floormod() [1/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::floormod | ( | const MArray< T > & | left,
|  | const MArray< T > & | right )

inline

Definition at line 664 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::combineMask(), floormod(), and casacore::MArrayBase::isNull().

Referenced by floormod(), floormod(), and floormod().

## floormod() [2/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::floormod | ( | const MArray< T > & | left,
|  | const T & | right )

inline

Definition at line 670 of file MArrayMath.h.

References casacore::MArray< T >::array(), and floormod().

## floormod() [3/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::floormod | ( | const T & | left,
|  | const MArray< T > & | right )

inline

Definition at line 674 of file MArrayMath.h.

References casacore::MArray< T >::array(), and floormod().

## fmod() [1/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::fmod | ( | const MArray< T > & | left,
|  | const MArray< T > & | right )

inline

Definition at line 650 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::combineMask(), fmod(), and casacore::MArrayBase::isNull().

Referenced by fmod(), fmod(), and fmod().

## fmod() [2/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::fmod | ( | const MArray< T > & | left,
|  | const T & | right )

inline

Definition at line 656 of file MArrayMath.h.

References casacore::MArray< T >::array(), and fmod().

## fmod() [3/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::fmod | ( | const T & | left,
|  | const MArray< T > & | right )

inline

Definition at line 660 of file MArrayMath.h.

References casacore::MArray< T >::array(), and fmod().

## fractile()

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::fractile | ( | const MArray< T > & | a,
|  | Float | fraction,
|  | Bool | sorted = False,
|  | Bool | inPlace = False )

inline

Return the fractile of an array.

It returns the value at the given fraction of the array. A fraction of 0.5 is the same as the median, be it that no mean of the two middle elements is taken if the array has an even nr of elements. It uses kthLargest if the array is not sorted yet.

The normal fractile function needs at least one element, so shortcut.

Definition at line 880 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::empty(), casacore::False, casacore::MArray< T >::flatten(), fractile(), casacore::MArrayBase::hasMask(), casacore::SHARE, casacore::MArrayBase::size(), casacore::Block< T >::storage(), and casacore::True.

Referenced by fractile(), and casacore::MArrayMath_global_functions_MArray_mathematical_operations::MFractileFunc< T >::operator()().

## imag() [1/2]

MArray< Float > casacore::MArrayMath_global_functions_MArray_mathematical_operations::imag | ( | const MArray< Complex > & | arr | ) |

inline

Definition at line 684 of file MArrayMath.h.

References casacore::MArray< T >::array(), and imag().

Referenced by imag(), and imag().

## imag() [2/2]

MArray< Double > casacore::MArrayMath_global_functions_MArray_mathematical_operations::imag | ( | const MArray< DComplex > & | arr | ) |

inline

Definition at line 696 of file MArrayMath.h.

References casacore::MArray< T >::array(), and imag().

## log()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::log | ( | const MArray< T > & | a | ) |

inline

Definition at line 560 of file MArrayMath.h.

References casacore::MArray< T >::array(), and log().

Referenced by log().

## log10()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::log10 | ( | const MArray< T > & | a | ) |

inline

Definition at line 564 of file MArrayMath.h.

References casacore::MArray< T >::array(), and log10().

Referenced by log10().

## max() [1/4]

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::max | ( | const MArray< T > & | a | ) |

inline

Definition at line 763 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::Array< T >::begin(), casacore::Array< T >::cbegin(), casacore::ArrayBase::contiguousStorage(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::mask(), and max().

## max() [2/4]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::max | ( | const MArray< T > & | left,
|  | const MArray< T > & | right )

inline

Definition at line 612 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::combineMask(), casacore::MArrayBase::isNull(), and max().

Referenced by max(), max(), max(), max(), and casacore::MArrayMath_global_functions_MArray_mathematical_operations::MMaxFunc< T >::operator()().

## max() [3/4]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::max | ( | const MArray< T > & | left,
|  | const T & | right )

inline

Definition at line 618 of file MArrayMath.h.

References casacore::MArray< T >::array(), and max().

## max() [4/4]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::max | ( | const T & | left,
|  | const MArray< T > & | right )

inline

Definition at line 622 of file MArrayMath.h.

References casacore::MArray< T >::array(), and max().

## mean()

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::mean | ( | const MArray< T > & | a | ) |

inline

Definition at line 776 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), mean(), casacore::MArrayBase::nvalid(), and sum().

Referenced by avdev(), avdev(), mean(), casacore::MArrayMath_global_functions_MArray_mathematical_operations::MMeanFunc< T >::operator()(), stddev(), variance(), and variance().

## median() [1/3]

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::median | ( | const MArray< T > & | a | ) |

inline

Definition at line 865 of file MArrayMath.h.

References casacore::False, median(), and casacore::MArrayBase::size().

## median() [2/3]

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::median | ( | const MArray< T > & | a,
|  | Bool | sorted )

inline

Definition at line 868 of file MArrayMath.h.

References casacore::False, median(), and casacore::MArrayBase::nelements().

## median() [3/3]

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::median | ( | const MArray< T > & | a,
|  | Bool | sorted,
|  | Bool | takeEvenMean,
|  | Bool | inPlace = False )

inline

The normal median function needs at least one element, so shortcut.

Median can be taken in place.

Definition at line 851 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::empty(), casacore::False, casacore::MArray< T >::flatten(), casacore::MArrayBase::hasMask(), median(), casacore::SHARE, casacore::Block< T >::size(), casacore::MArrayBase::size(), casacore::Block< T >::storage(), and casacore::True.

Referenced by median(), median(), median(), medianInPlace(), and casacore::MArrayMath_global_functions_MArray_mathematical_operations::MMedianFunc< T >::operator()().

## medianInPlace()

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::medianInPlace | ( | const MArray< T > & | a,
|  | Bool | sorted = False )

inline

Definition at line 871 of file MArrayMath.h.

References casacore::False, median(), casacore::MArrayBase::nelements(), and casacore::True.

## min() [1/4]

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::min | ( | const MArray< T > & | a | ) |

inline

Definition at line 750 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::Array< T >::begin(), casacore::Array< T >::cbegin(), casacore::ArrayBase::contiguousStorage(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::mask(), and min().

## min() [2/4]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::min | ( | const MArray< T > & | left,
|  | const MArray< T > & | right )

inline

Definition at line 598 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::combineMask(), casacore::MArrayBase::isNull(), and min().

Referenced by min(), min(), min(), min(), and casacore::MArrayMath_global_functions_MArray_mathematical_operations::MMinFunc< T >::operator()().

## min() [3/4]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::min | ( | const MArray< T > & | left,
|  | const T & | right )

inline

Definition at line 604 of file MArrayMath.h.

References casacore::MArray< T >::array(), and min().

## min() [4/4]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::min | ( | const T & | left,
|  | const MArray< T > & | right )

inline

Definition at line 608 of file MArrayMath.h.

References casacore::MArray< T >::array(), and min().

## operator%() [1/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator% | ( | const MArray< T > & | left,
|  | const MArray< T > & | right )

inline

Definition at line 405 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::combineMask(), and casacore::MArrayBase::isNull().

## operator%() [2/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator% | ( | const MArray< T > & | left,
|  | const T & | right )

inline

Definition at line 445 of file MArrayMath.h.

References casacore::MArray< T >::array().

## operator%() [3/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator% | ( | const T & | left,
|  | const MArray< T > & | right )

inline

Definition at line 477 of file MArrayMath.h.

References casacore::MArray< T >::array().

## operator&() [1/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator& | ( | const MArray< T > & | left,
|  | const MArray< T > & | right )

inline

Definition at line 411 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::combineMask(), and casacore::MArrayBase::isNull().

## operator&() [2/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator& | ( | const MArray< T > & | left,
|  | const T & | right )

inline

Definition at line 449 of file MArrayMath.h.

References casacore::MArray< T >::array().

## operator&() [3/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator& | ( | const T & | left,
|  | const MArray< T > & | right )

inline

Definition at line 481 of file MArrayMath.h.

References casacore::MArray< T >::array().

## operator*() [1/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator* | ( | const MArray< T > & | left,
|  | const MArray< T > & | right )

inline

Definition at line 393 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::combineMask(), and casacore::MArrayBase::isNull().

## operator*() [2/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator* | ( | const MArray< T > & | left,
|  | const T & | right )

inline

Definition at line 437 of file MArrayMath.h.

References casacore::MArray< T >::array().

## operator*() [3/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator* | ( | const T & | left,
|  | const MArray< T > & | right )

inline

Definition at line 469 of file MArrayMath.h.

References casacore::MArray< T >::array().

## operator+() [1/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator+ | ( | const MArray< T > & | left,
|  | const MArray< T > & | right )

inline

Add, subtract, etc.

2 arrays or array and scalar.

Definition at line 381 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::combineMask(), and casacore::MArrayBase::isNull().

## operator+() [2/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator+ | ( | const MArray< T > & | left,
|  | const T & | right )

inline

Definition at line 429 of file MArrayMath.h.

References casacore::MArray< T >::array().

## operator+() [3/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator+ | ( | const T & | left,
|  | const MArray< T > & | right )

inline

Definition at line 461 of file MArrayMath.h.

References casacore::MArray< T >::array().

## operator-() [1/4]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator- | ( | const MArray< T > & | a | ) |

inline

Negate the elements in an array.

Definition at line 495 of file MArrayMath.h.

References casacore::MArray< T >::array().

## operator-() [2/4]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator- | ( | const MArray< T > & | left,
|  | const MArray< T > & | right )

inline

Definition at line 387 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::combineMask(), and casacore::MArrayBase::isNull().

## operator-() [3/4]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator- | ( | const MArray< T > & | left,
|  | const T & | right )

inline

Definition at line 433 of file MArrayMath.h.

References casacore::MArray< T >::array().

## operator-() [4/4]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator- | ( | const T & | left,
|  | const MArray< T > & | right )

inline

Definition at line 465 of file MArrayMath.h.

References casacore::MArray< T >::array().

## operator/() [1/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator/ | ( | const MArray< T > & | left,
|  | const MArray< T > & | right )

inline

Definition at line 399 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::combineMask(), and casacore::MArrayBase::isNull().

## operator/() [2/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator/ | ( | const MArray< T > & | left,
|  | const T & | right )

inline

Definition at line 441 of file MArrayMath.h.

References casacore::MArray< T >::array().

## operator/() [3/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator/ | ( | const T & | left,
|  | const MArray< T > & | right )

inline

Definition at line 473 of file MArrayMath.h.

References casacore::MArray< T >::array().

## operator^() [1/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator^ | ( | const MArray< T > & | left,
|  | const MArray< T > & | right )

inline

Definition at line 423 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::combineMask(), and casacore::MArrayBase::isNull().

## operator^() [2/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator^ | ( | const MArray< T > & | left,
|  | const T & | right )

inline

Definition at line 457 of file MArrayMath.h.

References casacore::MArray< T >::array().

## operator^() [3/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator^ | ( | const T & | left,
|  | const MArray< T > & | right )

inline

Definition at line 489 of file MArrayMath.h.

References casacore::MArray< T >::array().

## operator|() [1/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator| | ( | const MArray< T > & | left,
|  | const MArray< T > & | right )

inline

Definition at line 417 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::combineMask(), and casacore::MArrayBase::isNull().

## operator|() [2/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator| | ( | const MArray< T > & | left,
|  | const T & | right )

inline

Definition at line 453 of file MArrayMath.h.

References casacore::MArray< T >::array().

## operator|() [3/3]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator| | ( | const T & | left,
|  | const MArray< T > & | right )

inline

Definition at line 485 of file MArrayMath.h.

References casacore::MArray< T >::array().

## operator~()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::operator~ | ( | const MArray< T > & | a | ) |

inline

Take the complement of the elements in an array.

Definition at line 500 of file MArrayMath.h.

References casacore::MArray< T >::array().

## partialArrayMath() [1/2]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::partialArrayMath | ( | const MArray< T > & | a,
|  | const IPosition & | collapseAxes,
|  | const MArrayFunctorBase< T > & | funcObj )

inline

Do partial reduction of an MArray object.

I.e., perform the operation on a subset of the array axes (the collapse axes).

Definition at line 186 of file MArrayMath.h.

References partialArrayMath().

Referenced by partialArrayMath(), partialAvdevs(), partialFractiles(), partialMaxs(), partialMeans(), partialMedians(), partialMins(), partialProducts(), partialRmss(), partialStddevs(), partialSums(), partialSumSqrs(), and partialVariances().

## partialArrayMath() [2/2]

template<typename T, typename RES>

void casacore::MArrayMath_global_functions_MArray_mathematical_operations::partialArrayMath | ( | MArray< RES > & | res,
|  | const MArray< T > & | a,
|  | const IPosition & | collapseAxes,
|  | const MArrayFunctorBase< T, RES > & | funcObj )

inline

This can also be done as boxedArrayMath with a removeDegenerate thereafter.

It should be possible to parallelize this loop. Determine nr of iteration steps and iterate over that as an int. Do not use Array slicing, because that is not thread-safe. Instead create ArraySTLIterator directly from Array and blc,trc, so funcObj should accept iterators instead of Array. However, ArraySTLIterator needs the sliced array, not original. Maybe keep ref of itsSteps in iterator instead of array. Hmm, tricky for median and fractile. Better to make Array copy ctor thread-safe (thus use boost shared_ptr).

IPosition shape(a.array().shape().removeAxes (collapseAxes));

Definition at line 195 of file MArrayMath.h.

References AlwaysAssert, casacore::MArray< T >::array(), casacore::ReadOnlyArrayIterator< T >::array(), casacore::Array< T >::data(), casacore::False, casacore::MArrayBase::hasMask(), casacore::MArrayBase::mask(), casacore::mask(), casacore::ReadOnlyArrayIterator< T >::next(), casacore::ReadOnlyArrayIterator< T >::pastEnd(), casacore::MArray< T >::resize(), casacore::MArrayBase::setMask(), casacore::shape(), and casacore::True.

## partialAvdevs()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::partialAvdevs | ( | const MArray< T > & | a,
|  | const IPosition & | collapseAxes )

inline

Definition at line 988 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), partialArrayMath(), and partialAvdevs().

Referenced by partialAvdevs().

## partialFractiles()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::partialFractiles | ( | const MArray< T > & | a,
|  | const IPosition & | collapseAxes,
|  | Float | fraction,
|  | Bool | inPlace = False )

inline

Definition at line 1025 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::False, casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), partialArrayMath(), and partialFractiles().

Referenced by partialFractiles().

## partialMaxs()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::partialMaxs | ( | const MArray< T > & | a,
|  | const IPosition & | collapseAxes )

inline

Definition at line 942 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), partialArrayMath(), and partialMaxs().

Referenced by partialMaxs().

## partialMeans()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::partialMeans | ( | const MArray< T > & | a,
|  | const IPosition & | collapseAxes )

inline

Definition at line 953 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), partialArrayMath(), and partialMeans().

Referenced by partialMeans().

## partialMedians()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::partialMedians | ( | const MArray< T > & | a,
|  | const IPosition & | collapseAxes,
|  | Bool | takeEvenMean = False,
|  | Bool | inPlace = False )

inline

Definition at line 1010 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::False, casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), partialArrayMath(), and partialMedians().

Referenced by partialMedians().

## partialMins()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::partialMins | ( | const MArray< T > & | a,
|  | const IPosition & | collapseAxes )

inline

Definition at line 931 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), partialArrayMath(), and partialMins().

Referenced by partialMins().

## partialProducts()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::partialProducts | ( | const MArray< T > & | a,
|  | const IPosition & | collapseAxes )

inline

Definition at line 920 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), partialArrayMath(), and partialProducts().

Referenced by partialProducts().

## partialRmss()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::partialRmss | ( | const MArray< T > & | a,
|  | const IPosition & | collapseAxes )

inline

Definition at line 999 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), partialArrayMath(), and partialRmss().

Referenced by partialRmss().

## partialStddevs()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::partialStddevs | ( | const MArray< T > & | a,
|  | const IPosition & | collapseAxes,
|  | uInt | ddof )

inline

Definition at line 976 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), partialArrayMath(), and partialStddevs().

Referenced by partialStddevs().

## partialSums()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::partialSums | ( | const MArray< T > & | a,
|  | const IPosition & | collapseAxes )

inline

Get partial sums, etc.

Definition at line 897 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), partialArrayMath(), and partialSums().

Referenced by partialSums().

## partialSumSqrs()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::partialSumSqrs | ( | const MArray< T > & | a,
|  | const IPosition & | collapseAxes )

inline

Definition at line 908 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), and partialArrayMath().

## partialVariances()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::partialVariances | ( | const MArray< T > & | a,
|  | const IPosition & | collapseAxes,
|  | uInt | ddof )

inline

Definition at line 964 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), partialArrayMath(), and partialVariances().

Referenced by partialVariances().

## phase() [1/2]

MArray< Float > casacore::MArrayMath_global_functions_MArray_mathematical_operations::phase | ( | const MArray< Complex > & | arr | ) |

inline

Definition at line 690 of file MArrayMath.h.

References casacore::MArray< T >::array(), and phase().

Referenced by phase(), and phase().

## phase() [2/2]

MArray< Double > casacore::MArrayMath_global_functions_MArray_mathematical_operations::phase | ( | const MArray< DComplex > & | arr | ) |

inline

Definition at line 702 of file MArrayMath.h.

References casacore::MArray< T >::array(), and phase().

## pow() [1/4]

template<typename T>

MArray< std::complex< T > > casacore::MArrayMath_global_functions_MArray_mathematical_operations::pow | ( | const MArray< std::complex< T > > & | a,
|  | const T & | exp )

inline

Definition at line 594 of file MArrayMath.h.

References exp(), and pow().

## pow() [2/4]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::pow | ( | const MArray< T > & | a,
|  | const MArray< T > & | exp )

inline

Definition at line 580 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::combineMask(), exp(), casacore::MArrayBase::isNull(), and pow().

Referenced by pow(), pow(), pow(), and pow().

## pow() [3/4]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::pow | ( | const MArray< T > & | a,
|  | const T & | exp )

inline

Definition at line 590 of file MArrayMath.h.

References casacore::MArray< T >::array(), exp(), and pow().

## pow() [4/4]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::pow | ( | const T & | a,
|  | const MArray< T > & | exp )

inline

Definition at line 586 of file MArrayMath.h.

References exp(), and pow().

## product()

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::product | ( | const MArray< T > & | a | ) |

inline

Definition at line 737 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::Array< T >::begin(), casacore::Array< T >::cbegin(), casacore::ArrayBase::contiguousStorage(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::mask(), and product().

Referenced by casacore::MArrayMath_global_functions_MArray_mathematical_operations::MProductFunc< T >::operator()(), and product().

## real() [1/2]

MArray< Float > casacore::MArrayMath_global_functions_MArray_mathematical_operations::real | ( | const MArray< Complex > & | arr | ) |

inline

Definition at line 681 of file MArrayMath.h.

References casacore::MArray< T >::array(), and real().

Referenced by real(), and real().

## real() [2/2]

MArray< Double > casacore::MArrayMath_global_functions_MArray_mathematical_operations::real | ( | const MArray< DComplex > & | arr | ) |

inline

Definition at line 693 of file MArrayMath.h.

References casacore::MArray< T >::array(), and real().

## rms()

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::rms | ( | const MArray< T > & | a | ) |

inline

Definition at line 837 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::Array< T >::begin(), casacore::Array< T >::cbegin(), casacore::ArrayBase::contiguousStorage(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::mask(), casacore::MArrayBase::nvalid(), rms(), sqrt(), and sum().

Referenced by casacore::MArrayMath_global_functions_MArray_mathematical_operations::MRmsFunc< T >::operator()(), and rms().

## round()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::round | ( | const MArray< T > & | a | ) |

inline

Definition at line 634 of file MArrayMath.h.

References casacore::MArray< T >::array(), and round().

Referenced by round().

## sign()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::sign | ( | const MArray< T > & | a | ) |

inline

Definition at line 638 of file MArrayMath.h.

References casacore::MArray< T >::array(), and sign().

Referenced by sign().

## sin()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::sin | ( | const MArray< T > & | a | ) |

inline

Perform mathematical function on each element in an array.

Definition at line 506 of file MArrayMath.h.

References casacore::MArray< T >::array(), and sin().

Referenced by sin().

## sinh()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::sinh | ( | const MArray< T > & | a | ) |

inline

Definition at line 518 of file MArrayMath.h.

References casacore::MArray< T >::array(), and sinh().

Referenced by sinh().

## slidingArrayMath() [1/2]

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::slidingArrayMath | ( | const MArray< T > & | array,
|  | const IPosition & | halfBoxShape,
|  | const MArrayFunctorBase< T > & | funcObj,
|  | Bool | fillEdge = True )

inline

Definition at line 305 of file MArrayMath.h.

References casacore::array, slidingArrayMath(), and casacore::True.

Referenced by slidingArrayMath(), slidingAvdevs(), slidingFractiles(), slidingMaxs(), slidingMeans(), slidingMedians(), slidingMins(), slidingProducts(), slidingRmss(), slidingStddevs(), slidingSums(), slidingSumSqrs(), and slidingVariances().

## slidingArrayMath() [2/2]

template<typename T, typename RES>

void casacore::MArrayMath_global_functions_MArray_mathematical_operations::slidingArrayMath | ( | MArray< RES > & | res,
|  | const MArray< T > & | array,
|  | const IPosition & | halfBoxShape,
|  | const MArrayFunctorBase< T, RES > & | funcObj,
|  | Bool | fillEdge = True )

inline

Loop through all data and assemble as needed.

Definition at line 315 of file MArrayMath.h.

References AlwaysAssert, casacore::array, casacore::MArray< T >::array(), casacore::Array< T >::begin(), casacore::empty(), casacore::False, casacore::fillSlidingShape(), casacore::MArrayBase::mask(), casacore::mask(), casacore::ndim(), casacore::Array< T >::reference(), casacore::MArray< T >::resize(), casacore::MArrayBase::setMask(), casacore::shape(), and casacore::True.

## slidingAvdevs()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::slidingAvdevs | ( | const MArray< T > & | a,
|  | const IPosition & | halfBoxSize,
|  | Bool | fillEdge = True )

inline

Definition at line 1144 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), slidingArrayMath(), and casacore::True.

## slidingFractiles()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::slidingFractiles | ( | const MArray< T > & | a,
|  | const IPosition & | halfBoxSize,
|  | Float | fraction,
|  | Bool | inPlace = False,
|  | Bool | fillEdge = True )

inline

Definition at line 1187 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::False, casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), slidingArrayMath(), and casacore::True.

## slidingMaxs()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::slidingMaxs | ( | const MArray< T > & | a,
|  | const IPosition & | halfBoxSize,
|  | Bool | fillEdge = True )

inline

Definition at line 1092 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), slidingArrayMath(), and casacore::True.

## slidingMeans()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::slidingMeans | ( | const MArray< T > & | a,
|  | const IPosition & | halfBoxSize,
|  | Bool | fillEdge = True )

inline

Definition at line 1104 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), slidingArrayMath(), and casacore::True.

## slidingMedians()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::slidingMedians | ( | const MArray< T > & | a,
|  | const IPosition & | halfBoxSize,
|  | Bool | takeEvenMean = False,
|  | Bool | inPlace = False,
|  | Bool | fillEdge = True )

inline

Definition at line 1168 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::False, casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), slidingArrayMath(), and casacore::True.

## slidingMins()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::slidingMins | ( | const MArray< T > & | a,
|  | const IPosition & | halfBoxSize,
|  | Bool | fillEdge = True )

inline

Definition at line 1080 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), slidingArrayMath(), and casacore::True.

## slidingProducts()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::slidingProducts | ( | const MArray< T > & | a,
|  | const IPosition & | halfBoxSize,
|  | Bool | fillEdge = True )

inline

Definition at line 1068 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), slidingArrayMath(), and casacore::True.

## slidingRmss()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::slidingRmss | ( | const MArray< T > & | a,
|  | const IPosition & | halfBoxSize,
|  | Bool | fillEdge = True )

inline

Definition at line 1156 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), slidingArrayMath(), and casacore::True.

## slidingStddevs()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::slidingStddevs | ( | const MArray< T > & | a,
|  | const IPosition & | halfBoxSize,
|  | uInt | ddof,
|  | Bool | fillEdge = True )

inline

Definition at line 1130 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), slidingArrayMath(), and casacore::True.

## slidingSums()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::slidingSums | ( | const MArray< T > & | a,
|  | const IPosition & | halfBoxSize,
|  | Bool | fillEdge = True )

inline

Get sliding sums.

Definition at line 1044 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), slidingArrayMath(), and casacore::True.

## slidingSumSqrs()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::slidingSumSqrs | ( | const MArray< T > & | a,
|  | const IPosition & | halfBoxSize,
|  | Bool | fillEdge = True )

inline

Definition at line 1056 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), slidingArrayMath(), and casacore::True.

## slidingVariances()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::slidingVariances | ( | const MArray< T > & | a,
|  | const IPosition & | halfBoxSize,
|  | uInt | ddof,
|  | Bool | fillEdge = True )

inline

Definition at line 1116 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::isNull(), slidingArrayMath(), and casacore::True.

## sqrt()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::sqrt | ( | const MArray< T > & | a | ) |

inline

Definition at line 568 of file MArrayMath.h.

References casacore::MArray< T >::array(), and sqrt().

Referenced by rms(), sqrt(), stddev(), and stddev().

## square()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::square | ( | const MArray< T > & | a | ) |

inline

Definition at line 572 of file MArrayMath.h.

References casacore::MArray< T >::array(), and square().

Referenced by square().

## stddev() [1/2]

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::stddev | ( | const MArray< T > & | a,
|  | T | mean,
|  | uInt | ddof )

inline

Definition at line 811 of file MArrayMath.h.

References mean(), sqrt(), and variance().

## stddev() [2/2]

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::stddev | ( | const MArray< T > & | a,
|  | uInt | ddof )

inline

Definition at line 805 of file MArrayMath.h.

References sqrt(), and variance().

Referenced by casacore::MArrayMath_global_functions_MArray_mathematical_operations::MStddevFunc< T >::operator()().

## sum()

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::sum | ( | const MArray< T > & | a | ) |

inline

Reduce an array to a scalar using the unmasked elements only.

The result is 0 if there are no unmasked elements.

Definition at line 711 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::Array< T >::begin(), casacore::Array< T >::cbegin(), casacore::ArrayBase::contiguousStorage(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::mask(), and sum().

Referenced by avdev(), mean(), casacore::MArrayMath_global_functions_MArray_mathematical_operations::MSumFunc< T >::operator()(), rms(), sum(), and variance().

## sumsqr()

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::sumsqr | ( | const MArray< T > & | a | ) |

inline

Definition at line 724 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::Array< T >::begin(), casacore::Array< T >::cbegin(), casacore::ArrayBase::contiguousStorage(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::mask(), and sumsqr().

Referenced by casacore::MArrayMath_global_functions_MArray_mathematical_operations::MSumSqrFunc< T >::operator()(), and sumsqr().

## tan()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::tan | ( | const MArray< T > & | a | ) |

inline

Definition at line 514 of file MArrayMath.h.

References casacore::MArray< T >::array(), and tan().

Referenced by tan().

## tanh()

template<typename T>

MArray< T > casacore::MArrayMath_global_functions_MArray_mathematical_operations::tanh | ( | const MArray< T > & | a | ) |

inline

Definition at line 526 of file MArrayMath.h.

References casacore::MArray< T >::array(), and tanh().

Referenced by tanh().

## variance() [1/2]

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::variance | ( | const MArray< T > & | a,
|  | T | mean,
|  | uInt | ddof )

inline

Definition at line 785 of file MArrayMath.h.

References casacore::MArray< T >::array(), casacore::Array< T >::begin(), casacore::Array< T >::cbegin(), casacore::ArrayBase::contiguousStorage(), casacore::MArrayBase::hasMask(), casacore::MArrayBase::mask(), mean(), casacore::MArrayBase::nvalid(), and sum().

Referenced by casacore::MArrayMath_global_functions_MArray_mathematical_operations::MVarianceFunc< T >::operator()(), stddev(), stddev(), and variance().

## variance() [2/2]

template<typename T>

T casacore::MArrayMath_global_functions_MArray_mathematical_operations::variance | ( | const MArray< T > & | a,
|  | uInt | ddof )

inline

Definition at line 799 of file MArrayMath.h.

References mean(), and variance().

The documentation for this struct was generated from the following file:

- tables/TaQL/MArrayMath.h